package io.dropwizard.testing.app;

import java.util.Objects;

public class Person {
    private String name = "";
    private String email = "";

    public Person() { /* Jackson deserialization */ }

    public Person(String name, String email) {
        this.name = name;
        this.email = email;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, email);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null || getClass() != obj.getClass()) {
            return false;
        }
        final Person other = (Person) obj;
        return Objects.equals(this.name, other.name) && Objects.equals(this.email, other.email);
    }

    @Override
    public String toString() {
        return "Person{" + "name='" + name + "'" + ", email='" + email + "'}";
    }
}
